unit EditorUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TEditorBox }

  TEditorBox = class(TForm)
    btOpen: TButton;
    btSave: TButton;
    btClose: TButton;
    mCode: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure btCloseClick(Sender: TObject);
    procedure btOpenClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  EditorBox: TEditorBox;

function RunEditor(Caption, Value: string): string;

implementation

function RunEditor(Caption, Value: string): string;
begin
  Application.CreateForm(TEditorBox, EditorBox);
  EditorBox.mCode.Text:=Value;
  EditorBox.Caption:=Caption;
  EditorBox.ShowModal;
  Result:=EditorBox.mCode.Text;
  FreeAndNil(EditorBox);
end;

{$R *.lfm}

{ TEditorBox }

procedure TEditorBox.btOpenClick(Sender: TObject);
begin
  if OpenDialog1.Execute then try
    mCode.Lines.LoadFromFile(OpenDialog1.FileName);
  except
    ShowMessage('Failed to load the file ' + OpenDialog1.FileName);
  end;
end;

procedure TEditorBox.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TEditorBox.btSaveClick(Sender: TObject);
begin
  if SaveDialog1.Execute then try
    mCode.Lines.SaveToFile(SaveDialog1.FileName);
  except
    ShowMessage('Failed to save the file ' + SaveDialog1.FileName);
  end;
end;

procedure TEditorBox.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=27 then Close;
end;

end.

